//=============================================================================
// zcServerBoard.
// (C) 2002 by Zora
//=============================================================================
class zcServerBoard expands UnrealScoreBoard;

const XColSpacing = 10.0;				// space between columns

// config section
var() config	color	RowColor[8];	// support different rows colors

// client side variables
var float	XsCol[8];					// size of columns
var float	xs, ys, yl;					// last total size of menu, row height

var int		SbriCnt;

var zcServerBoardReplicationInfo	SBRI[32];

struct zcServerBoardRow {
	var	float			xs[ArrayCount(XsCol)];
};

var zcServerBoardRow	Element[ArrayCount(SBRI)];	// all elements

simulated function PostBeginPlay()
{
	// log( "zcServerBoard " $ self $ " PostBeginPlay(), owner=" $ Owner );

	if ( Owner == None || PlayerPawn(Owner) == None ) {
		// || !PlayerPawn(Owner).bAdmin ) {
		// log( Owner $ " isn't admin - using default score board" );
		// PlayerPawn(Owner).ScoringType = Level.Game.ScoreboardType;
		destroy();
		return ;
	}
	SbriCnt = 0;
}

function ShowScores( canvas C )
{
	local int jdx, sdx;
	local bool bChanged;
	local float xp, yp, xc, yc, xh, yh;
	local zcServerBoardReplicationInfo sbi;
	local string val;

	C.Font = RegFont;

	// Header
	DrawHeader( C );

	// Trailer
	DrawTrailer( C );

	bChanged = False;
	sdx = 0;
	foreach AllActors( class'zcServerBoard.zcServerBoardReplicationInfo', sbi ) {
		if ( sbi.ColorIndex == 0 ) {
			SBRI[sdx] = SBRI[0];
			SBRI[0] = sbi;
		}
		else SBRI[sdx] = sbi;
		if ( sbi.DataIsChanged() ) bChanged = True;
		if ( ++sdx >= ArrayCount(SBRI) ) break;
	}
	if ( sdx == 0 ) return;

	if ( bChanged || sdx != SbriCnt ) {
		// new data encountered, (re-)calculate layout
		for ( jdx = sdx; jdx < SbriCnt; jdx++ ) {
			SBRI[jdx] = None;
		}
		SbriCnt = sdx;

		xs = 0;
		yl = 0;

		for ( jdx = 0; jdx < ArrayCount(XsCol); jdx++ ) {
			XsCol[jdx] = 0;
			for ( sdx = 0; sdx < SbriCnt; sdx++ ) {
				C.StrLen( SBRI[sdx].ElementRead( jdx ), Element[sdx].xs[jdx], ys );
				if ( Element[sdx].xs[jdx] > XsCol[jdx] ) XsCol[jdx] = Element[sdx].xs[jdx];
				if ( ys > yl ) yl = ys;
			}
			xs += XsCol[jdx];
		}

		yl *= 1.5;
	}

	xp = (C.ClipX - (xs + (ArrayCount(XsCol) - 1) * XColSpacing)) / 2;
	yp = (C.ClipY - yl * SbriCnt) / 2;
	if ( yp > C.ClipY / 4 ) yp = C.ClipY / 4;

	// log( "xs=" $ xs $ ", ys=" $ ys $ ", yl=" $ yl $ ", xp=" $ xp $ ", yp=" $ yp );

	// plot the menu
	for ( jdx = 0; jdx < ArrayCount(XsCol); jdx++ ) {
		yc = yp;
		for ( sdx = 0; sdx < SbriCnt; sdx++ ) {
			//if ( jdx == 5 ) val = string(SBRI[sdx].PRI);
			//else
			if ( SBRI[sdx].PRI != None ) {
				if ( SBRI[0].ElementRead( jdx ) ~= "Ping" ) val = string(SBRI[sdx].PRI.Ping);
				else if ( SBRI[0].ElementRead( jdx ) ~= "Frag" ) val = string(int(SBRI[sdx].PRI.Score));
				else val = SBRI[sdx].ElementRead( jdx );
			}
			else val = SBRI[sdx].ElementRead( jdx );
			C.StrLen( val, xh, yh );
			C.DrawColor = RowColor[Clamp( SBRI[sdx].ColorIndex, 0, ArrayCount(RowColor)-1 )];
			switch ( SBRI[0].Align[jdx] ) {
				case SBA_Right:		C.SetPos( xp + XsCol[jdx] - xh, yc );		break;
				case SBA_Left:		C.SetPos( xp, yc );						break;
				case SBA_Center:	// fall through ...
				default:			C.SetPos( xp + (XsCol[jdx] - xh) / 2, yc );	break;

			}
			C.DrawText( val, false );
			yc += yl;
		}
		xp += XsCol[jdx] + XColSpacing;
	}

	C.DrawColor.R = 255;
	C.DrawColor.G = 255;
	C.DrawColor.B = 255;
}

//=================================== EOF =====================================

defaultproperties
{
				RowColor(0)=(R=255,G=255,B=255)
				RowColor(1)=(G=255)
				RowColor(2)=(R=255,G=255)
				RowColor(3)=(R=255)
				RowColor(4)=(R=128,G=255,B=255)
				RowColor(5)=(R=208,G=11,B=251)
				RowColor(6)=(R=144,G=144,B=144)
				RowColor(7)=(B=255)
}
